---
title: "Assign an authorization role"
description: "Assigns a role to an account at platform or tenant context after checking the live assignment matrix and capability intersection.\n\n### Quire permissions\n\nRequired capability: `platform/roles_assign`.\n\nCredential scopes: `roles:write`.\n\nThe acting subject must also be allowed to perform this action in the organisation."
image: "https://docs.quirelms.com/og.png"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.quirelms.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Quire API › roles

`POST /platform/role_assignments`

Assigns a role to an account at platform or tenant context after checking the live assignment matrix and capability intersection.

\### Quire permissions

Required capability: `platform/roles_assign`.

Credential scopes: `roles:write`.

The acting subject must also be allowed to perform this action in the organisation.

## Authentication

Requires one of the following:

- `apiKey`, http, header `Authorization`, scopes: `roles:write`
- `oauth2`, oauth2, scopes: `roles:write`

## Header parameters

- `assignPlatformAuthorizationRole.header.Idempotency-Key` (string, required) — A caller-chosen key making this request safe to retry. A replay of a completed request returns the recorded response with `Idempotency-Replayed: true`. Reusing a key for a different request is refused.
  - maxLength 255
- `assignPlatformAuthorizationRole.header.Quire-Version` (string, optional) — The dated API revision to serve this request at. Omitted, the request is served at the revision the credential was issued against. The response echoes the revision actually applied.
  - format `date`

## Request body

_Required._

- `assignPlatformAuthorizationRole.user_id` (string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`
- `assignPlatformAuthorizationRole.role_id` (string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`
- `assignPlatformAuthorizationRole.context` (one of, optional)
  - one of: `object`, `object`

## Example request

```json
{
  "user_id": "a169451c-8525-4352-b8ca-070dd449a1a5",
  "role_id": "ac4e70c8-d5be-48af-93eb-760f58fc91a9",
  "context": {
    "kind": "platform"
  }
}
```

## Code samples

### cURL

```curl
curl --request POST \
  --url https://your-organisation.quirelms.com/api/v1/platform/role_assignments \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'Idempotency-Key: string' \
  --data '
{
  "user_id": "a169451c-8525-4352-b8ca-070dd449a1a5",
  "role_id": "ac4e70c8-d5be-48af-93eb-760f58fc91a9",
  "context": {
    "kind": "platform"
  }
}
'
```

### TypeScript

```typescript
const url = 'https://your-organisation.quirelms.com/api/v1/platform/role_assignments';
const options = {
  method: 'POST',
  headers: {
    'Content-Type': 'application/json',
    'Idempotency-Key': 'string',
    Authorization: 'Bearer <token>'
  },
  body: JSON.stringify({
    user_id: 'a169451c-8525-4352-b8ca-070dd449a1a5',
    role_id: 'ac4e70c8-d5be-48af-93eb-760f58fc91a9',
    context: {kind: 'platform'}
  })
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://your-organisation.quirelms.com/api/v1/platform/role_assignments"

payload = {
    "user_id": "a169451c-8525-4352-b8ca-070dd449a1a5",
    "role_id": "ac4e70c8-d5be-48af-93eb-760f58fc91a9",
    "context": { "kind": "platform" }
}
headers = {
    "Content-Type": "application/json",
    "Idempotency-Key": "string",
    "Authorization": "Bearer <token>"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 201

Success.

#### Example

```json
{
  "user_id": "a169451c-8525-4352-b8ca-070dd449a1a5",
  "role_id": "ac4e70c8-d5be-48af-93eb-760f58fc91a9"
}
```

- `assignPlatformAuthorizationRole.response.201.user_id` (string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`
- `assignPlatformAuthorizationRole.response.201.role_id` (string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`

### 401

The credential is missing, malformed, expired or revoked.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `assignPlatformAuthorizationRole.response.401.type` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.401.title` (string, required)
- `assignPlatformAuthorizationRole.response.401.status` (integer, required)
- `assignPlatformAuthorizationRole.response.401.code` (string, required)
- `assignPlatformAuthorizationRole.response.401.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `assignPlatformAuthorizationRole.response.401.detail` (string, required)
- `assignPlatformAuthorizationRole.response.401.request_id` (string, required)
- `assignPlatformAuthorizationRole.response.401.docs_url` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.401.errors` (array<object>, optional)
  - `assignPlatformAuthorizationRole.response.401.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `assignPlatformAuthorizationRole.response.401.errors.code` (string, required)
  - `assignPlatformAuthorizationRole.response.401.errors.detail` (string, required)
- `assignPlatformAuthorizationRole.response.401.retry_after` (integer | null, optional)

### 403

The credential lacks the scope this operation requires, or the acting subject lacks the capability.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `assignPlatformAuthorizationRole.response.403.type` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.403.title` (string, required)
- `assignPlatformAuthorizationRole.response.403.status` (integer, required)
- `assignPlatformAuthorizationRole.response.403.code` (string, required)
- `assignPlatformAuthorizationRole.response.403.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `assignPlatformAuthorizationRole.response.403.detail` (string, required)
- `assignPlatformAuthorizationRole.response.403.request_id` (string, required)
- `assignPlatformAuthorizationRole.response.403.docs_url` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.403.errors` (array<object>, optional)
  - `assignPlatformAuthorizationRole.response.403.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `assignPlatformAuthorizationRole.response.403.errors.code` (string, required)
  - `assignPlatformAuthorizationRole.response.403.errors.detail` (string, required)
- `assignPlatformAuthorizationRole.response.403.retry_after` (integer | null, optional)

### 409

The request conflicts with the current state, with a previous use of the same idempotency key, or with a concurrent write.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `assignPlatformAuthorizationRole.response.409.type` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.409.title` (string, required)
- `assignPlatformAuthorizationRole.response.409.status` (integer, required)
- `assignPlatformAuthorizationRole.response.409.code` (string, required)
- `assignPlatformAuthorizationRole.response.409.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `assignPlatformAuthorizationRole.response.409.detail` (string, required)
- `assignPlatformAuthorizationRole.response.409.request_id` (string, required)
- `assignPlatformAuthorizationRole.response.409.docs_url` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.409.errors` (array<object>, optional)
  - `assignPlatformAuthorizationRole.response.409.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `assignPlatformAuthorizationRole.response.409.errors.code` (string, required)
  - `assignPlatformAuthorizationRole.response.409.errors.detail` (string, required)
- `assignPlatformAuthorizationRole.response.409.retry_after` (integer | null, optional)

### 422

The request was understood and its content is not valid. `errors` names each field.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `assignPlatformAuthorizationRole.response.422.type` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.422.title` (string, required)
- `assignPlatformAuthorizationRole.response.422.status` (integer, required)
- `assignPlatformAuthorizationRole.response.422.code` (string, required)
- `assignPlatformAuthorizationRole.response.422.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `assignPlatformAuthorizationRole.response.422.detail` (string, required)
- `assignPlatformAuthorizationRole.response.422.request_id` (string, required)
- `assignPlatformAuthorizationRole.response.422.docs_url` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.422.errors` (array<object>, optional)
  - `assignPlatformAuthorizationRole.response.422.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `assignPlatformAuthorizationRole.response.422.errors.code` (string, required)
  - `assignPlatformAuthorizationRole.response.422.errors.detail` (string, required)
- `assignPlatformAuthorizationRole.response.422.retry_after` (integer | null, optional)

### 429

A rate limit or a concurrency cap was reached. `Retry-After` says when to try again.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `assignPlatformAuthorizationRole.response.429.type` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.429.title` (string, required)
- `assignPlatformAuthorizationRole.response.429.status` (integer, required)
- `assignPlatformAuthorizationRole.response.429.code` (string, required)
- `assignPlatformAuthorizationRole.response.429.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `assignPlatformAuthorizationRole.response.429.detail` (string, required)
- `assignPlatformAuthorizationRole.response.429.request_id` (string, required)
- `assignPlatformAuthorizationRole.response.429.docs_url` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.429.errors` (array<object>, optional)
  - `assignPlatformAuthorizationRole.response.429.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `assignPlatformAuthorizationRole.response.429.errors.code` (string, required)
  - `assignPlatformAuthorizationRole.response.429.errors.detail` (string, required)
- `assignPlatformAuthorizationRole.response.429.retry_after` (integer | null, optional)

### 500

Something failed at our end. Quote `request_id` when reporting it.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `assignPlatformAuthorizationRole.response.500.type` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.500.title` (string, required)
- `assignPlatformAuthorizationRole.response.500.status` (integer, required)
- `assignPlatformAuthorizationRole.response.500.code` (string, required)
- `assignPlatformAuthorizationRole.response.500.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `assignPlatformAuthorizationRole.response.500.detail` (string, required)
- `assignPlatformAuthorizationRole.response.500.request_id` (string, required)
- `assignPlatformAuthorizationRole.response.500.docs_url` (string, required)
  - format `uri`
- `assignPlatformAuthorizationRole.response.500.errors` (array<object>, optional)
  - `assignPlatformAuthorizationRole.response.500.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `assignPlatformAuthorizationRole.response.500.errors.code` (string, required)
  - `assignPlatformAuthorizationRole.response.500.errors.detail` (string, required)
- `assignPlatformAuthorizationRole.response.500.retry_after` (integer | null, optional)


Source: https://docs.quirelms.com/api/roles/assignPlatformAuthorizationRole/index.md
